﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;//追加(出力のために必要)
using System.Text.RegularExpressions;//追加(入力に制限をために必要)

namespace Dices
{
    public partial class Form1 : Base1
    {

        Regex notIntReg = new Regex("[^0-9]"); //数字以外にマッチする

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }


        private void number_t_TextChanged(object sender, EventArgs e)
        {
            number_t.Text= notIntReg.Replace(number_t.Text, "");
        }

        private void max_t_TextChanged(object sender, EventArgs e)
        {
            max_t.Text = notIntReg.Replace(max_t.Text, "");
        }

        private void trial_t_TextChanged(object sender, EventArgs e)
        {
            trial_t.Text = notIntReg.Replace(trial_t.Text, "");
        }

        private void button1_Click(object sender, EventArgs e)
        {

            //記入漏れがあった時の処理
            if ((number_t.Text == "" || max_t.Text == "" || trial_t.Text == ""))
            {
                MessageBox.Show("数字の指定もれがあります");
                result_t.Clear();
                return;
            }

            //数字が0だった時の処理
            if ((number_t.Text == "0" || max_t.Text == "0" || trial_t.Text == "0"))
            {
                MessageBox.Show("数字の0は使用できません。１以上の数字を指定してください");
                result_t.Clear();
                return;
            }

            int number = Convert.ToInt32(number_t.Text);//ダイスの数
            int max = Convert.ToInt32(max_t.Text); ;//ダイスの最大の出目
            int trial= Convert.ToInt32(trial_t.Text); ;//試行回数

            //ファイル名を宣言
            string file_name = number+"d"+max+"_trial"+trial+".txt";//ファイル名を宣言

            //ファイルの出力
            FileStream fs = new FileStream(file_name, FileMode.Create);//上書き保存する
            StreamWriter sw = new StreamWriter(fs);

            //初期条件
            sw.Write("//[条件]" + max + "面体のダイスを" + number + "回振る\r\n" +
                "//[試行回数]" + trial + "\r\n" +
                "//[保存ファイル名]" + file_name + "\r\n" +
                "\r\n" +
                "//回目\tダイスの数の和\r\n");

            //乱数
            int seed = Environment.TickCount;
            Random rnd = new System.Random();// インスタンスを生成

            for (int i = 1; i <= trial; i++)
            {
                int dice = 0;

                for(int k=0; k < number; k++)
                {
                dice +=rnd.Next(1, max + 1);
                }
                sw.Write(i+"\t"+dice+"\r\n");
            }

            sw.Close();//ファイルを閉じる
            result_t.Clear();//右窓をいったんクリアにする
            StreamReader sr = new StreamReader(file_name);
            result_t.Text = sr.ReadToEnd();//右窓に結果を表示
            sr.Close();
            MessageBox.Show("結果は" + file_name + "に保存されました。");





        }


        private void result_t_TextChanged(object sender, EventArgs e)
        {

        }

        //以降はlabelをクリックして開いてしまった分。(無視してください)
        private void label2_Click(object sender, EventArgs e)
        {

        }
        private void dice_t_Click(object sender, EventArgs e)
        {

        }


    }
}
